Do not rely on git internals, support Git >= 2.10
[fast-export.git] / hg-fast-export.sh
blobf3f58f60e6e395922279a8850e9c879b163a69ee
1 #!/bin/sh
3 # Copyright (c) 2007, 2008 Rocco Rutte <pdmef@gmx.net> and others.
4 # License: MIT <http://www.opensource.org/licenses/mit-license.php>
6 ROOT="$(dirname "$(which "$0")")"
7 REPO=""
8 PFX="hg2git"
9 SFX_MAPPING="mapping"
10 SFX_MARKS="marks"
11 SFX_HEADS="heads"
12 SFX_STATE="state"
13 GFI_OPTS=""
14 PYTHON=${PYTHON:-python}
16 USAGE="[--quiet] [-r <repo>] [--force] [-m <max>] [-s] [--hgtags] [-A <file>] [-B <file>] [-T <file>] [-M <name>] [-o <name>] [--hg-hash] [-e <encoding>]"
17 LONG_USAGE="Import hg repository <repo> up to either tip or <max>
18 If <repo> is omitted, use last hg repository as obtained from state file,
19 GIT_DIR/$PFX-$SFX_STATE by default.
21 Note: The argument order matters.
23 Options:
24 --quiet Passed to git-fast-import(1)
25 -r <repo> Mercurial repository to import
26 --force Ignore validation errors when converting, and pass --force
27 to git-fast-import(1)
28 -m <max> Maximum revision to import
29 -s Enable parsing Signed-off-by lines
30 --hgtags Enable exporting .hgtags files
31 -A <file> Read author map from file
32 (Same as in git-svnimport(1) and git-cvsimport(1))
33 -B <file> Read branch map from file
34 -T <file> Read tags map from file
35 -M <name> Set the default branch name (defaults to 'master')
36 -o <name> Use <name> as branch namespace to track upstream (eg 'origin')
37 --hg-hash Annotate commits with the hg hash as git notes in the
38 hg namespace.
39 -e <encoding> Assume commit and author strings retrieved from
40 Mercurial are encoded in <encoding>
41 --fe <filename_encoding> Assume filenames from Mercurial are encoded
42 in <filename_encoding>
44 case "$1" in
45 -h|--help)
46 echo "usage: $(basename "$0") $USAGE"
47 echo ""
48 echo "$LONG_USAGE"
49 exit 0
50 esac
52 cd $(git rev-parse --show-toplevel) \
53 || (echo "Could not find git repo" ; exit 1)
54 GIT_DIR=$(git rev-parse --git-dir) || exit 1
56 while case "$#" in 0) break ;; esac
58 case "$1" in
59 -r|--r|--re|--rep|--repo)
60 shift
61 REPO="$1"
63 --q|--qu|--qui|--quie|--quiet)
64 GFI_OPTS="$GFI_OPTS --quiet"
66 --force)
67 # pass --force to git-fast-import and hg-fast-export.py
68 GFI_OPTS="$GFI_OPTS --force"
69 break
71 -*)
72 # pass any other options down to hg2git.py
73 break
76 break
78 esac
79 shift
80 done
82 # for convenience: get default repo from state file
83 if [ x"$REPO" = x -a -f "$GIT_DIR/$PFX-$SFX_STATE" ] ; then
84 REPO="`grep '^:repo ' "$GIT_DIR/$PFX-$SFX_STATE" | cut -d ' ' -f 2`"
85 echo "Using last hg repository \"$REPO\""
88 if [ -z "$REPO" ]; then
89 echo "no repo given, use -r flag"
90 exit 1
93 # make sure we have a marks cache
94 if [ ! -f "$GIT_DIR/$PFX-$SFX_MARKS" ] ; then
95 touch "$GIT_DIR/$PFX-$SFX_MARKS"
98 # cleanup on exit
99 trap 'rm -f "$GIT_DIR/$PFX-$SFX_MARKS.old" "$GIT_DIR/$PFX-$SFX_MARKS.tmp"' 0
101 _err1=
102 _err2=
103 exec 3>&1
104 { read -r _err1 || :; read -r _err2 || :; } <<-EOT
106 exec 4>&3 3>&1 1>&4 4>&-
108 _e1=0
109 GIT_DIR="$GIT_DIR" $PYTHON "$ROOT/hg-fast-export.py" \
110 --repo "$REPO" \
111 --marks "$GIT_DIR/$PFX-$SFX_MARKS" \
112 --mapping "$GIT_DIR/$PFX-$SFX_MAPPING" \
113 --heads "$GIT_DIR/$PFX-$SFX_HEADS" \
114 --status "$GIT_DIR/$PFX-$SFX_STATE" \
115 "$@" 3>&- || _e1=$?
116 echo $_e1 >&3
117 } | \
119 _e2=0
120 git fast-import $GFI_OPTS --export-marks="$GIT_DIR/$PFX-$SFX_MARKS.tmp" 3>&- || _e2=$?
121 echo $_e2 >&3
125 exec 3>&-
126 [ "$_err1" = 0 -a "$_err2" = 0 ] || exit 1
128 # move recent marks cache out of the way...
129 if [ -f "$GIT_DIR/$PFX-$SFX_MARKS" ] ; then
130 mv "$GIT_DIR/$PFX-$SFX_MARKS" "$GIT_DIR/$PFX-$SFX_MARKS.old"
131 else
132 touch "$GIT_DIR/$PFX-$SFX_MARKS.old"
135 # ...to create a new merged one
136 cat "$GIT_DIR/$PFX-$SFX_MARKS.old" "$GIT_DIR/$PFX-$SFX_MARKS.tmp" \
137 | uniq > "$GIT_DIR/$PFX-$SFX_MARKS"
139 # save SHA1s of current heads for incremental imports
140 # and connectivity (plus sanity checking)
141 for head in `git branch | sed 's#^..##'` ; do
142 id="`git rev-parse refs/heads/$head`"
143 echo ":$head $id"
144 done > "$GIT_DIR/$PFX-$SFX_HEADS"
146 # check diff with color:
147 # ( for i in `find . -type f | grep -v '\.git'` ; do diff -u $i $REPO/$i ; done | cdiff ) | less -r